''
''   Ŀ
''                       CorelSCSI!  Ver. 2.0                      
''   Ĵ
''                      Setup Script Ver. 1.08                     
''                                                                 
''                                                                 
''      - SETUP Configuration file for Corel English Version       
''                                                                 
''      - Created  October 18, 1993.                               
''      - Modified December 22, 1993 by S.R.                       
''                                                                 
''   Ĵ
''                                                                 
''    Copyright (C) 1993.  Corel Corporation   All Rights Reserved 
''                                                                 
''   
''                                                                  


''''''$DEFINE DEBUG  ''Define for script development/debugging

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

'' code to make the install the full screen

CONST WS_VISIBLE=&H10000000
CONST WS_BORDER =&H00800000
CONST WS_CLIPCHILDREN =&H02000000
CONST GWL_STYLE =-16
CONST SW_SHOWMAXIMIZED=3

DECLARE FUNCTION ShowWindow LIB "user.exe" (hWnd%,iShow%) AS INTEGER
DECLARE FUNCTION SetWindowLong LIB "user.exe" (hWnd%,offset%,style&) AS LONG

hWnd%=HwndFrame()

sti&=SetWindowLong(hWnd%,GWL_STYLE,WS_VISIBLE+WS_BORDER+WS_CLIPCHILDREN)
stj%=ShowWindow(hWnd%,SW_SHOWMAXIMIZED)
   
''OEM ID's
CONST OEM_UNIVERSAL		= 1
CONST OEM_CDSTUFF		= 2
CONST OEM_CORELBOOK		= 4
CONST OEM_WINBACKUP		= 8
CONST OEM_DOSBACKUP		= 16
CONST OEM_WINTOOLS		= 32
CONST OEM_DOSTOOLS		= 64
CONST OEM_WINCONFIG		= 128
CONST OEM_DOSCONFIG		= 256
CONST OEM_TWAIN			= 512   

CONST CORELSCSI20		= 1
CONST CORELCDPAK		= 2
CONST OEMVERSION		= 3                                                          

CONST DISK			= 1
CONST CD_DISK			= 2

''
''
'' Set InstallType = CORELSCSI20    '' this is for the CorelSCSI 2.0 Setup.
''      	   = CORELCDPAK	    '' this is for the Corel CD PowerPak Setup.
''		   = OEMVERSION	    '' this is for the OEM Setup Version.
'' 
'' Set InstallSet = 0	for CorelSCSI 2.0 and Corel CD PowerPak    
''     InstallSet = ??  depends on what the OEM version is to have. Can choose 
''			from the following :
''  		        OEM_UNIVERSAL, OEM_CDSTUFF, OEM_CORELBOOK, OEM_WINBACKUP,
''                      OEM_DOSBACKUP, OEM_WINTOOLS, OEM_DOSTOOLS, OEM_WINCONFIG,
''                      OEM_DOSCONFIG, OEM_TWAIN
''         for example, to OEM  CorelBook, Windows Backup, and Windows Config then
''  		        InstallSet = OEM_CORELBOOK + OEM_WINBACKUP + OEM_WINCONFIG
''
''		DiskOrCD  = DISK | CD_DISK	FOR POWERPAK ONLY. 
''                          Set to DISK for the drivers install ONLY
''			    Set to CD_DISK for the rest of the software from the CDROM
''
''
'' * NOTE * 		if you are using OEM make sure InstallType = OEMVERSION 
''
''

CONST InstallType	= CORELSCSI20    '' this is for the CorelSCSI 2.0 Setup.
CONST InstallSet	= 0                
CONST DiskOrCD		= CD_DISK	'' this is for the CDROM disk version

GLOBAL  OEM_NAME_PLATE$ 

OEM_NAME_PLATE$ = "Corel Version"     	'' 30 chars max


''Dialog ID's
CONST WELCOME       = 300
CONST WLCMCD	    = 299              	'' the PowerPak splash screen
CONST CUSTOMCD	    = 298	       	'' the PowerPak custom box
CONST PATHOK        = 301
CONST PATHFND       = 302
CONST CUSTOM        = 303
CONST METHOD        = 304
CONST ENDSCRN       = 305
CONST QUIT          = 306
CONST AUTOCNFG      = 307
CONST PATHSCRN      = 308
CONST README        = 309
CONST READTXT       = 310
CONST BADPATH       = 312
CONST ASKQUIT       = 314
CONST EXITSUCCESS   = 316
CONST EXITFAILURE   = 318
CONST EXITQUIT      = 320
CONST DSKSPCE       = 322
CONST TESTBACK      = 324
CONST CHKSPCE       = 326
CONST METHDHLP      = 327
CONST CUSTMHLP      = 328
CONST PATHHLP       = 329
CONST ASPIDRVR      = 330
CONST CHSECARD      = 331
CONST FDTDC950      = 332
CONST CHSCDHLP      = 333
CONST DEVHIGH       = 334
CONST NOVSURE       = 335
CONST ENDSCRN2      = 336
CONST OEMCARD       = 337
CONST OEMLIST       = 338
CONST OEMINFO	    = 339
CONST CDDEVHIGH	    = 340 	'' powerpak dev high box
CONST DISKINFO	    = 341 	'' powerpak Disk setup info box
CONST PTHFNDCD	    = 342 	'' powerpak CD portion Found so install here
CONST CSTOMCD2	    = 343                                
CONST MOSAIC	    = 344 	'' Mosaic Confirm Box
CONST LSTDRV	    = 345
CONST LSTDRVHP	    = 346
CONST LSTDRVN	    = 347
CONST OTHRDISK		= 348

''Billboards
CONST CONFIG1       = 350
CONST BACKUP1       = 352
CONST REGISTER      = 354
CONST CDAUD2	    = 356
CONST CDBASE		= 357

''Bitmap ID nums for Billboards
CONST CONFIG1_BIT   = 1050
CONST BACKUP1_BIT   = 1055
CONST REGISTER_BIT  = 1060
CONST CDAUD2_BIT    = 1065
CONST CDBASE_BIT    = 1070


''Bitmap ID
CONST CORELSCSI2_LOGO = 1
CONST CORELCDPAK_LOGO = 2

''File Types
CONST UNIFILES        = 1
CONST CDFILES         = 2
CONST CORELBOOKFILES  = 3
CONST WIN_BACKUPFILES = 4
CONST WIN_TOOLSFILES  = 5
CONST WIN_CONFIGFILES = 6
CONST WIN_TWAINFILES  = 7
CONST WIN_MOSAICFILES = 7 	'' same as the twain stuff
CONST DOS_BACKUPFILES = 8
CONST DOS_TOOLSFILES  = 9
CONST DOS_CONFIGFILES = 10
CONST NECESSARY_FILES = 11

GLOBAL DEST$        ''Default destination directory.
GLOBAL FDCspecial$  ''MUST MATCH!!!! ~aspi.lst name
GLOBAL OEMDisk$     ''MUST MATCH!!!! Other name
GLOBAL OEMPATH$                               
GLOBAL OTHERDISK$
GLOBAL REBOOT$      ''to reboot or not to reboot
GLOBAL OPTCUR$      ''Option selection from option dialog.
GLOBAL MosDir$      ''Location of old mosaic program, if found.

GLOBAL CHECKSTATES$
GLOBAL STATUSTEXT$
GLOBAL DRIVETEXT$
GLOBAL APPS%
GLOBAL DoTheMosaic%

GLOBAL UNINEED$
GLOBAL CDNEED$
GLOBAL CORELBOOKNEED$
GLOBAL WIN_BACKUPNEED$
GLOBAL WIN_TOOLSNEED$
GLOBAL WIN_CONFIGNEED$
GLOBAL WIN_TWAINNEED$
GLOBAL DOS_BACKUPNEED$
GLOBAL DOS_TOOLSNEED$
GLOBAL DOS_CONFIGNEED$
GLOBAL NECESSARY_NEED$
GLOBAL PCDMOSNEED$
GLOBAL EXTRACOSTS$
GLOBAL BIGLIST$

GLOBAL CORRUPT$
GLOBAL ERRORSTRING$ 
GLOBAL oldestpath$ 
GLOBAL CallBackDlg$

DECLARE SUB cpRegisterDefaults LIB "cpalette.dll"
DECLARE SUB DoBackGround
DECLARE SUB Install
DECLARE FUNCTION SetOEMText  LIB "stv.dll" (sz$) AS INTEGER
DECLARE SUB AddOptFilesToCopyList (ftype%)
DECLARE SUB CheckPath 

DECLARE FUNCTION RemSymbol  LIB "stv.dll" (sz$) AS INTEGER

DECLARE SUB RecalcOptFiles (ftype%)
DECLARE SUB RecalcPath
DECLARE SUB SetDriveStatus
DECLARE SUB SetCheckStateList
DECLARE FUNCTION SetFullInstallSize LIB "stv.dll" (sz$) AS INTEGER
DECLARE FUNCTION CheckIfOEM  LIB "stv.dll" (set%, against%) AS INTEGER
DECLARE FUNCTION SetBillBrdNum LIB "stv.dll" (num%) AS INTEGER         
DECLARE FUNCTION SetDebugInfo LIB "stv.dll" () AS INTEGER
DECLARE FUNCTION KillScreenSave LIB "stv.dll" () AS INTEGER
DECLARE FUNCTION RestoreScreenSave LIB "stv.dll" () AS INTEGER
DECLARE FUNCTION OnOtherDisk LIB "stv.dll" () AS INTEGER

INIT:                                                         
''	nRc% = SetDebugInfo()
	nRc% = KillScreenSave()
    CUIDLL$ = "stv.dll"            ''Custom user interface dll
    FDCspecial$ = "FDC TMC-950 /W BIOS REV < 8.2"       ''Must Match ~aspi.lst name all uppercase
    OEMDisk$ = "OTHER (REQUIRES DISK FROM OEM...)"      ''Must Match ~aspi.lst name all uppercase

	CORRUPT$ = "Setup sources were corrupted, call Corel!"
	ERRORSTRING$ = "Error"
	
	IF InstallType = CORELCDPAK  THEN		'' takes care of the BITMAP LOGO (2 types)
		SetBitmap CUIDLL$, CORELCDPAK_LOGO
		SetTitle "Corel CD PowerPak! Setup"
	ELSE
		SetBitmap CUIDLL$, CORELSCSI2_LOGO 
		SetTitle "CorelSCSI! 2"
	END IF	                       

    szInf$ = GetSymbolValue("STF_SRCINFPATH")
    IF szInf$ = "" THEN
        szInf$ = GetSymbolValue("STF_CWDDIR") + "SETUP.INF"
    END IF
    ReadInfFile szInf$

    OPTCUR$ = "1"
    DEST$ = "C:\CORELDRV"

    CHECKSTATES$ = "CheckItemsState"
    STATUSTEXT$ = "StatusItemsText"
    DRIVETEXT$ = "DriveStatusText"

    SetCheckStateList

    FOR i% = 1 TO 11 STEP 1
       AddListItem STATUSTEXT$, ""
    NEXT i%

    FOR i% = 1 TO 7 STEP 1
       AddListItem DRIVETEXT$,""
    NEXT i%

    drive$ = MID$(DEST$, 1, 1)

    free& = GetFreeSpaceForDrive(drive$)
    ReplaceListItem DRIVETEXT$, 3, STR$(free& / 1024) + " K"
    ReplaceListItem DRIVETEXT$, 7, DEST$

    UNINEED$  = "UniNeed"
    CDNEED$  = "CDNeed"
    CORELBOOKNEED$  = "CorelBookNeed"
    WIN_BACKUPNEED$  = "Win_BackupNeed"
    WIN_TOOLSNEED$   = "Win_ToolsNeed"
    WIN_CONFIGNEED$  = "Win_ConfigNeed"
    WIN_TWAINNEED$   = "Win_TwainNeed" 				'' in case of PowerPak this is really Mosaic Stuff
    DOS_BACKUPNEED$  = "Dos_BackupNeed"
    DOS_TOOLSNEED$   = "Dos_ToolsNeed"
    DOS_CONFIGNEED$  = "Dos_ConfigNeed"
    PCDMOSNEED$		 = "PcdMosNeeds"
    NECESSARY_NEED$  = "Necessary"
    EXTRACOSTS$ = "ExtraCosts"
    BIGLIST$ = "BigList"


    FOR i% = 1 TO 11 STEP 1
        AddListItem BIGLIST$, ""
    NEXT i%
    FOR i% = 1 TO 26 STEP 1
        AddListItem EXTRACOSTS$, "0"
    NEXT i%

'$IFDEF DEBUG
    i% = SetSizeCheckMode(scmOnIgnore)    '' could use scmOff; def = scmOnFatal
    WinDrive$ = MID$(GetWindowsDir, 1, 1)
    IF IsDriveValid(WinDrive$) = 0 THEN
        i% = DoMsgBox("Windows drive ('"+WinDrive$+"') is not a valid drive.", "DEBUG", MB_TASKMODAL+MB_ICONHAND+MB_OK)
        GOTO QUIT
    END IF
'$ENDIF ''DEBUG

WELCOME: 
	nret% = SetBillBrdNum(REGISTER_BIT)
    AddToBillboardList CUIDLL$, REGISTER, "FModelessBillBoardDlgProc", 1
	nret% = SetBillBrdNum(CONFIG1_BIT)
    AddToBillboardList CUIDLL$, CONFIG1, "FModelessBillBoardDlgProc", 1
	nret% = SetBillBrdNum(CDAUD2_BIT)
    AddToBillboardList CUIDLL$, CDAUD2, "FModelessBillBoardDlgProc", 1
	nret% = SetBillBrdNum(CDBASE_BIT)
    AddToBillboardList CUIDLL$, CDBASE, "FModelessBillBoardDlgProc", 1

	IF InstallType <> CORELCDPAK  THEN 	'' add the backup one if not a powerpak install
		nret% = SetBillBrdNum(BACKUP1_BIT)
	    AddToBillboardList CUIDLL$, BACKUP1, "FModelessBillBoardDlgProc", 1
	END IF
	DoBackGround    
WELCOME2:                                                        
	IF InstallType = CORELCDPAK  THEN 	'' takes care of the splash screen (2 types)
		temp% = WLCMCD
	ELSE
		temp% = WELCOME
	END IF	                       

	
    sz$ = UIStartDlg(CUIDLL$, temp%,"FModeless2DlgProc",0,"")
    cursor% = ShowWaitCursor()
    RecalcPath
    SetDriveStatus
    RestoreCursor cursor%

WELCOME3:    
		UIPop 1         
		IF InstallType = OEMVERSION THEN
			GOTO PATHSCRNFULL                                   
		ELSE
			IF InstallType = CORELCDPAK THEN
			  IF DiskOrCD = DISK THEN
				GOTO INFODISK
			  END IF 
			END IF			
			GOTO METHOD
		END IF
    IF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
    	sz$ = UIStartDlg(CUIDLL$, temp%,"FModeless2DlgProc",0,"")
		GOTO WELCOME2
    ELSE
        GOSUB ASKQUIT
		GOTO WELCOME2
    END IF


INFODISK:
    sz$ = UIStartDlg(CUIDLL$, DISKINFO, "FInfoDlgProc", 0, "")
    IF sz$ = "EXIT" THEN
        GOSUB ASKQUIT
        GOTO INFODISK
    ELSEIF sz$ = "CONTINUE" THEN
    	UIPop 1
    	GOTO PATHSCRNFULL
    ENDIF


METHOD:
    sz$ = UIStartDlg(CUIDLL$, METHOD, "FCustInstDlgProc", METHDHLP, "FHelpDlgProc")
    IF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO METHOD
    ELSEIF sz$ = "BTN1" THEN
        UIPop 1
        ''SetCheckStateList
''    FOR i% = 1 TO 14 STEP 1
''       AddListItem CHECKSTATES$, "ON"
''   NEXT i%
		GOTO PATHSCRNFULL
    ELSEIF sz$ = "BTN2" THEN
        UIPop 1          
        ''SetCheckStateList
''    FOR i% = 1 TO 14 STEP 1
''       AddListItem CHECKSTATES$, "ON"
''   NEXT i%
		GOTO PATHSCRN
    ELSEIF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO METHOD
    ELSE
		GOSUB ASKQUIT
		GOTO METHOD
    END IF


PATHSCRNFULL:
	IF InstallType = CORELCDPAK AND DiskOrCD = DISK THEN
	  stz% = RemSymbol(CHECKSTATES$)
	END IF

	SetCheckStateList


PATHSCRNFULL11:
	CheckPath

PATHSCRNFULL1:

	test$ = ""
    IF InstallType = CORELCDPAK THEN
      IF DiskOrCD = CD_DISK THEN
        test$ = GetIniKeyString("WIN.INI", "CorelSCSI", "PPak")
      END IF
    END IF

    IF CallBackDlg$ = "FEditDlgProc" THEN
      i% = PATHOK
    ELSE
      IF test$ = "PPAK" THEN
        i% = PTHFNDCD
      ELSE
        i% = PATHFND
      END IF
    END IF

    DEST$ = GetSymbolValue("EditTextOut")
    sz$ = UIStartDlg(CUIDLL$, i%, CallBackDlg$, PATHHLP, "FHelpDlgProc")
    olddest$ = DEST$
    DEST$ = GetSymbolValue("EditTextOut")


    IF sz$ = "CONTINUE" THEN
        i% = LEN(DEST$)                        '' lets take off the last slash if one exists
        oldestpath$ = MID$(DEST$, i%, 1)
        IF oldestpath$ = "\" THEN
          i% = i% - 1
        ENDIF
        oldestpath$ = MID$(DEST$, 1, i%)
        DEST$ = oldestpath$

        IF IsDirWritable(DEST$) = 0 THEN
		    GOSUB BADPATH
	   		GOTO PATHSCRNFULL1
		END IF
        drive$ = MID$(DEST$, 1, 1)

        free& = GetFreeSpaceForDrive(drive$)
        ReplaceListItem DRIVETEXT$, 3, STR$(free& / 1024) + " K"
        ''Truncate display if too long.
        IF LEN(DEST$) > 23 THEN
            ReplaceListItem DRIVETEXT$, 7, MID$(DEST$, 1, 23)+"..."
        ELSE
            ReplaceListItem DRIVETEXT$, 7, DEST$
	END IF


	olddest$ = ""

	UIPop 1

	IF InstallType = CORELCDPAK AND DiskOrCd = CD_DISK 	AND GetListItem(CHECKSTATES$, WIN_TWAINFILES) = "ON" THEN                       '' or the mosaic files 
		DoTheMosaic% = 0
		GOSUB ISMOSAIC
		IF DoTheMosaic% = 1 THEN
''		  DoBackground
		  GOTO ASKINST
''		ELSEIF DoTheMosaic% = 2 THEN
''		  GOSUB ASKQUIT  
''		  DoBackGround
''		  GOTO  PATHSCRNFULL11
		END IF
	END IF

''	SetCheckStateList

        cursor% = ShowWaitCursor()
        stm$ = UIStartDlg(CUIDLL$, CHKSPCE, "FModeless2DlgProc", 0, "")
        RecalcPath
        SetDriveStatus
        RestoreCursor cursor%
        UIPop 1
	drive$ = MID$(DEST$, 1, 1)
	free& = GetFreeSpaceForDrive(drive$) / 1024
	cost& = VAL(GetListItem(DRIVETEXT$, 2))
	IF (cost& > free&) THEN
	   GOSUB DSKSPCE
	   GOTO PATHSCRNFULL1
	ENDIF

''	DoTheMosaic% = 0
	Install     

''	IF DoTheMosaic% = 1 THEN
''	  DoBackground
''	  GOTO ASKINST2
''	ELSEIF DoTheMosaic% = 2 THEN
''       GOSUB ASKQUIT  
''        DoBackGround
''		GOTO  PATHSCRNFULL11
''	END IF


	GOTO ASPIDRVR
    ELSEIF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO PATHSCRNFULL1
    ELSEIF sz$ = "BACK" THEN
        UIPop 1
		IF InstallType = OEMVERSION  THEN
			GOTO WELCOME2
		ELSEIF InstallType = CORELCDPAK AND DiskOrCD = DISK THEN
		    GOTO INFODISK
		ELSE
			GOTO METHOD
		END IF
    ELSE
        GOSUB ASKQUIT
	GOTO PATHSCRNFULL1
    END IF


PATHSCRN:
	SetCheckStateList
PATHSCRN11:	
	CheckPath
PATHSCRN1:
	test$ = ""
    IF InstallType = CORELCDPAK THEN
      IF DiskOrCD = CD_DISK THEN
        test$ = GetIniKeyString("WIN.INI", "CorelSCSI", "PPak")
      END IF
    END IF

    IF CallBackDlg$ = "FEditDlgProc" THEN
      i% = PATHOK
    ELSE
      IF test$ = "PPAK" THEN
        i% = PTHFNDCD
      ELSE
        i% = PATHFND
      END IF
    END IF

    sz$ = UIStartDlg(CUIDLL$, i%, CallBackDlg$, PATHHLP, "FHelpDlgProc")

    olddest$ = DEST$
    DEST$ = GetSymbolValue("EditTextOut")


    IF sz$ = "CONTINUE" THEN
        i% = LEN(DEST$)                        '' lets take off the last slash if one exists
        oldestpath$ = MID$(DEST$, i%, 1)
    	IF oldestpath$ = "\" THEN
      	  i% = i% - 1
    	ENDIF

    	oldestpath$ = MID$(DEST$, 1, i%)
    	DEST$ = oldestpath$

        IF IsDirWritable(DEST$) = 0 THEN
		    GOSUB BADPATH
		    GOTO PATHSCRN1
		END IF

        drive$ = MID$(DEST$, 1, 1)
    	oldpath$=""
    	cdpath$=""

        free& = GetFreeSpaceForDrive(drive$)
        ReplaceListItem DRIVETEXT$, 3, STR$(free& / 1024) + " K"
	''Truncate display if too long.
        IF LEN(DEST$) > 23 THEN
            ReplaceListItem DRIVETEXT$, 7, MID$(DEST$, 1, 23)+"..."
        ELSE
            ReplaceListItem DRIVETEXT$, 7, DEST$
        END IF


		olddest$ = ""
        UIPop 1

		IF InstallType = CORELCDPAK AND DiskOrCd = CD_DISK 	AND GetListItem(CHECKSTATES$, WIN_TWAINFILES) = "ON" THEN                       '' or the mosaic files 
			DoTheMosaic% = 0
			GOSUB ISMOSAIC
			IF DoTheMosaic% = 1 THEN
''			  DoBackground
			  GOTO ASKINST
''	ELSEIF DoTheMosaic% = 2 THEN
''		  GOSUB ASKQUIT  
''		  DoBackGround
''		  GOTO  PATHSCRNFULL11
			END IF
		END IF

		GOTO ASKINST

    ELSEIF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO PATHSCRN1
    ELSEIF sz$ = "BACK" THEN
        UIPop 1
		GOTO METHOD
    ELSE
        GOSUB ASKQUIT
		GOTO PATHSCRN1
    END IF


ASKINST:
    cursor% = ShowWaitCursor()
    stm$ = UIStartDlg(CUIDLL$, CHKSPCE, "FModeless2DlgProc", 0, "")
    SetCheckStateList
    
    RecalcPath
    SetDriveStatus
    RestoreCursor cursor%
    UIPop 1
ASKINST2:
	test$ = ""
    IF InstallType = CORELCDPAK THEN
      IF DiskOrCD = CD_DISK THEN
        test$ = GetIniKeyString("WIN.INI", "CorelSCSI", "PPak")
      END IF
    END IF

	IF InstallType = CORELCDPAK  THEN			'' takes care of the splash screen (2 types)
		IF test$ = "PPAK" THEN
			temp% = CSTOMCD2
		ELSE
			temp% = CUSTOMCD
		END IF
	ELSE
		temp% = CUSTOM
	END IF	                       

    sz$ = UIStartDlg(CUIDLL$, temp%, "FCustInstDlgProc", CUSTMHLP, "FHelpDlgProc")
    IF sz$ = "EXIT" THEN
        GOSUB ASKQUIT
        GOTO ASKINST2
    ELSEIF sz$ = "CONTINUE" THEN
	drive$ = MID$(DEST$, 1, 1)
	free& = GetFreeSpaceForDrive(drive$) / 1024
        cost& = VAL(GetListItem(DRIVETEXT$, 2))
        IF (cost& > free&) THEN
	   GOSUB DSKSPCE
           GOTO ASKINST2
        ELSE
	   UIPopAll

	Install     

	END IF
    ELSEIF sz$ = "CHK1" THEN
	RecalcOptFiles UNIFILES
        SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "CHK2" THEN
	RecalcOptFiles CDFILES
        SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "CHK3" THEN
	RecalcOptFiles CORELBOOKFILES
        SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "CHK4" THEN
	RecalcOptFiles WIN_BACKUPFILES
        SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "CHK5" THEN
	RecalcOptFiles WIN_TOOLSFILES
        SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "CHK6" THEN
	RecalcOptFiles WIN_CONFIGFILES
        SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "CHK7" THEN
	    RecalcOptFiles WIN_TWAINFILES			'' in the PowerPak version this serves as the Mosaic Entry
        SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "CHK8" THEN
	RecalcOptFiles DOS_BACKUPFILES
        SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "CHK9" THEN
	RecalcOptFiles DOS_TOOLSFILES
        SetDriveStatus
	GOTO ASKINST2
    ELSEIF sz$ = "CHK10" THEN
	RecalcOptFiles DOS_CONFIGFILES
	SetDriveStatus
        GOTO ASKINST2
    ELSEIF sz$ = "REACTIVATE" THEN
        UIPopAll
		DoBackGround
		GOTO ASKINST2
    ELSEIF sz$ = "BACK" THEN
        UIPop 1
		GOTO PATHSCRN11
    ELSE
        GOSUB ASKQUIT
	GOTO ASKINST2
    END IF

ASPIDRVR:
    UIPopAll
	DoBackGround
ASPIDRVR2:
	IF InstallType = CORELCDPAK THEN 
	  test$ = ""
      IF DiskOrCD = CD_DISK THEN
        test$ = GetIniKeyString("WIN.INI", "CorelSCSI", "PPak")
      END IF
		  
	  IF test$ = "PPAK" THEN
	    GOTO AUTOCNFG
	  ELSE
	    IF GetListItem(CHECKSTATES$, CDFILES) = "OFF" THEN
		  GOTO DEVHIGH                                    
	    END IF 
	  END IF
	END IF           
	
    sz$ = UIStartDlg(CUIDLL$, ASPIDRVR, "FListDlgProc", CHSCDHLP, "FHelpDlgProc")
    IF sz$ = "REACTIVATE" THEN
	 	GOTO ASPIDRVR
    ELSEIF sz$ = "CONTINUE" THEN

		cardchosen$=GetSymbolValue("ListItemsOut")
		SetSymbolValue "OEMLIST", "NO"
		IF cardchosen$ = FDCspecial$ THEN
		  GOTO CHSECARD
		ELSEIF cardchosen$ = OEMDisk$ THEN
		  GOTO OEMCARD
		ELSE
		  stv% = OnOtherDisk()
''		  i% = DoMsgBox(STR$(stv%), "stv% is", MB_OK)
		  IF stv% = 1 THEN
			GOTO ONOTHERDISK
''		    i% = DoMsgBox("was on other disk", "blah", MB_OK)
		  END IF
		  		  
		  UIPop 1
		  GOTO DEVHIGH
	    ENDIF
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO ASPIDRVR2
    ELSE
        GOTO ASPIDRVR2
    END IF

ONOTHERDISK:
	OTHERDISK$ = GetIniKeyString("WIN.INI", "CorelSCSI", "OTHERPath")
	IF OTHERDISK$ = "" THEN
		OTHERDISK$ = GetSymbolValue("STF_SRCDIR")
	ENDIF
    SetSymbolValue "EditTextIn", OTHERDISK$
	sz$ = UIStartDlg(CUIDLL$, OTHRDISK, "FOtherEditDlgProc", 0,"")
    IF sz$ = "REACTIVATE" THEN
        UIPopAll
		DoBackGround
		GOTO ONOTHERDISK
    ELSEIF sz$ = "CONTINUE" THEN
 	   OTHERDISK$ = GetSymbolValue("EditTextOut")
	   CreateIniKeyValue "WIN.INI", "CorelSCSI", "OTHERPath", OEMPATH$, cmoOverwrite
	   UIPop 2
       GOTO DEVHIGH
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO ONOTHERDISK
    ELSEIF sz$ = "BACK" THEN
		UIPop 2
        GOTO ASPIDRVR2
	ELSE
		GOTO ONOTHERDISK
    END IF
	

CHSECARD:
    sz$ = UIStartDlg(CUIDLL$, CHSECARD, "FEditCardDlgProc", FDTDC950,"FHelpDlgProc")
    IF sz$ = "REACTIVATE" THEN
        UIPopAll
		DoBackGround
		GOTO CHSECARD
    ELSEIF sz$ = "CONTINUE" THEN
	UIPop 2
        GOTO DEVHIGH
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO CHSECARD
    ELSEIF sz$ = "BACK" THEN
	UIPop 1
        GOTO ASPIDRVR2
    ELSE
	GOTO CHSECARD
    END IF

OEMCARD:
	OEMPATH$ = GetIniKeyString("WIN.INI", "CorelSCSI", "OEMPath")
	IF OEMPATH$ = "" THEN
		OEMPATH$ = GetSymbolValue("STF_SRCDIR")
	ENDIF
   SetSymbolValue "EditTextIn", OEMPATH$
	sz$ = UIStartDlg(CUIDLL$, OEMCARD, "FOemEditDlgProc", 0,"")
    IF sz$ = "REACTIVATE" THEN
        UIPopAll
		DoBackGround
		GOTO OEMCARD
    ELSEIF sz$ = "CONTINUE" THEN
 	   OEMPATH$ = GetSymbolValue("EditTextOut")
	   CreateIniKeyValue "WIN.INI", "CorelSCSI", "OEMPath", OEMPATH$, cmoOverwrite
		UIPop 2
        GOTO OEMLIST
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO OEMCARD
    ELSEIF sz$ = "BACK" THEN
		UIPop 1
        GOTO ASPIDRVR2
	ELSE
		GOTO OEMCARD
    END IF

OEMLIST:
    sz$ = UIStartDlg(CUIDLL$, OEMLIST, "FOemListDlgProc", CHSCDHLP,"FHelpDlgProc")
    IF sz$ = "REACTIVATE" THEN
        UIPopAll
		DoBackGround
		GOTO OEMLIST
    ELSEIF sz$ = "CONTINUE" THEN
		SetSymbolValue "OEMLIST", "YES"
		UIPop 1
        GOTO DEVHIGH
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO OEMLIST
    ELSEIF sz$ = "BACK" THEN
		UIPop 1
        GOTO OEMCARD
	ELSE
		GOTO OEMLIST
    END IF

DEVHIGH:
	
    IF GetListItem(CHECKSTATES$, UNIFILES) = "OFF" AND GetListItem(CHECKSTATES$, CDFILES) = "OFF" THEN
      GOTO LASTDRIVE
    END IF

    SetSymbolValue "HighDevices", ""
    FOR i% = 1 TO 2 STEP 1                  '' do HIGH DEVICES
      AddListItem "HighDevices", "OFF"
    NEXT i%

	DosVer% = GetDOSMajorVersion()
	IF DosVer% < 5 THEN
	  GOTO LASTDRIVE
	END IF

DEVHIGH2:
	IF InstallType = CORELCDPAK  THEN			'' takes care of the splash screen (2 types)
		temp% = CDDEVHIGH
	ELSE
		temp% = DEVHIGH
	END IF	                       
	
    sz$ = UIStartDlg(CUIDLL$, temp%, "FCustInst2DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        UIPopAll
		DoBackGround
		GOTO DEVHIGH2
    ELSEIF sz$ = "CONTINUE" THEN
        UIPop 1
        GOTO LASTDRIVE
    ELSEIF sz$ = "EXIT" THEN
		GOSUB ASKQUIT
		GOTO DEVHIGH2
    ELSEIF sz$ = "HGH1" THEN
		GOTO DEVHIGH2
    ELSEIF sz$ = "HGH2" THEN
		GOTO DEVHIGH2
    ELSEIF sz$ = "HGH3" THEN
		GOTO DEVHIGH2
    ELSE
        UIPop 1
    END IF


LASTDRIVE:
    windowsys$ = GetWindowsDir() + "SYSTEM.INI"
    testnovell$ = GetIniKeyString(windowsys$, "boot", "network.drv")  
    temp% = LSTDRV
    IF testnovell$ = "netware.drv" OR testnovell$ = "NETWARE.DRV" THEN
	  temp% = LSTDRVN
    ELSE
      testnovell$ = GetIniKeyString(windowsys$, "boot", "secondnet.drv")
      IF testnovell$ = "netware.drv" OR testnovell$ = "NETWARE.DRV" THEN        
		temp% = LSTDRVN
      ENDIF
    ENDIF

    sz$ = UIStartDlg(CUIDLL$, temp%, "FLastDriveDlgProc", LSTDRVHP,"FHelpDlgProc")
    IF sz$ = "REACTIVATE" THEN
		GOTO LASTDRIVE
    ELSEIF sz$ = "CONTINUE" THEN
		UIPop 1
		GOTO AUTOCNFG
    ELSEIF sz$ = "EXIT" THEN
    	GOSUB ASKQUIT
		GOTO LASTDRIVE
    END IF
	

AUTOCNFG:
	IF InstallType = CORELCDPAK AND DiskOrCD = CD_DISK THEN
	  test$ = ""
      test$ = GetIniKeyString("WIN.INI", "CorelSCSI", "PPak")

	  IF test$ = "PPAK" THEN
	    SetSymbolValue "HighDevices", ""
	    FOR i% = 1 TO 2 STEP 1                  '' do HIGH DEVICES
 	     AddListItem "HighDevices", "OFF"
 	    NEXT i%
	  END IF
	END IF  

	IF InstallType = CORELCDPAK THEN 
	  test$ = ""
      IF DiskOrCD = CD_DISK THEN
        test$ = GetIniKeyString("WIN.INI", "CorelSCSI", "PPak")
      END IF
		  
	  IF test$ = "PPAK" THEN
	    GOTO README
	  END IF
	END IF
		
    sz$ = UIStartDlg(CUIDLL$, AUTOCNFG, "FInfo2DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        UIPopAll
		DoBackGround
		GOTO AUTOCNFG
    ELSEIF sz$ = "CONTINUE" THEN
		UIPop 1
        REBOOT$="YES"
		GOTO README
    ELSEIF sz$ = "EXIT" THEN
		UIPop 1
		REBOOT$="NO"
		GOTO README
    ELSE
        UIPop 1
    END IF


README:
	IF InstallType = CORELCDPAK THEN 
	  IF DiskOrCD = DISK THEN						'' if running the disk then don't need to do readme
		GOTO README2
	  END IF
	END IF  
	
    sz$ = UIStartDlg(CUIDLL$, README, "FInfoDlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
       UIPopAll
		DoBackGround
       GOTO README
    ELSEIF sz$ = "BACK" THEN                       ''had to make it something different
		UIPop 1
		GOTO READTXT
    ELSEIF sz$ = "EXIT" THEN
		UIPop 1
README2:
		IF REBOOT$ = "YES" THEN
		  GOTO ENDSCRN
		ELSE
		  GOTO ENDSCRN2
        END IF
    ELSE
		UIPop 1
        GOTO README
    END IF

READTXT:
    sz$ = UIStartDlg(CUIDLL$, READTXT, "FTXTInfoDlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO READTXT
    ELSEIF sz$ = "CONTINUE" THEN                       ''had to make it something different
		UIPop 1
		IF REBOOT$ = "YES" THEN
		  GOTO ENDSCRN
	    ELSE
	      GOTO ENDSCRN2
        END IF
    ELSE
		GOTO READTXT
    END IF

ENDSCRN:
    DECLARE FUNCTION WinExec LIB "krnl386.exe" (CMDLINE$, CMDSHOW%) AS INTEGER
	szPathsome$ = DEST$ + "\SCSIREBT.EXE /DOBOOT"
    sz$ = UIStartDlg(CUIDLL$, ENDSCRN, "FInfoDlgProc",0,"")
    IF sz$ = "EXIT" THEN
		UIPopAll
    ELSEIF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO ENDSCRN
	ELSEIF sz$ = "BACK" THEN
	   i%=WinExec(szPathsome$, 8)                   ''8 is sw_showna
		UIPopAll
   	ELSE
		UIPopAll
   	END IF

	  IF InstallType = CORELCDPAK THEN
	    IF DiskOrCD = DISK THEN		
	      CreateIniKeyValue "WIN.INI", "CorelSCSI", "PPak", "PPAK", cmoOverwrite
	    ELSEIF DiskOrCD = CD_DISK THEN
	      RemoveIniKey "WIN.INI", "CorelSCSI", "PPak", cmoNone
	    END IF
	  END IF

    nRc% = RestoreScreenSave()
		RemoveIniKey "WIN.INI", "CorelSCSI", "OEMPath", cmoNone
    	RemoveFile DEST$+"\~aspi.lst", cmoForce
    END

ENDSCRN2:
    sz$ = UIStartDlg(CUIDLL$, ENDSCRN2, "FInfoDlgProc",0,"")
    IF sz$ = "EXIT" THEN
		UIPopAll
    ELSEIF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO ENDSCRN2
    ELSE
		UIPopAll
    END IF

	  IF InstallType = CORELCDPAK THEN
	    IF DiskOrCD = DISK THEN		
	      CreateIniKeyValue "WIN.INI", "CorelSCSI", "PPak", "PPAK", cmoOverwrite
	    ELSEIF DiskOrCD = CD_DISK THEN
	      RemoveIniKey "WIN.INI", "CorelSCSI", "PPak", cmoNone
	    END IF
	  END IF

    nRc% = RestoreScreenSave()
	RemoveIniKey "WIN.INI", "CorelSCSI", "OEMPath", cmoNone
    RemoveFile DEST$+"\~aspi.lst", cmoForce
    END

QUIT:

    ON ERROR GOTO ERRQUIT

    IF ERR = STFQUIT THEN
        dlg% = EXITQUIT
    ELSE
        dlg% = EXITFAILURE
    END IF
QUITL1:
    sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO QUITL1
    END IF
    DECLARE SUB cpReleaseDefaults LIB "cpalette.dll"
    UIPopAll   
    nRc% = RestoreScreenSave()
	 RemoveIniKey "WIN.INI", "CorelSCSI", "OEMPath", cmoNone
    RemoveFile DEST$+"\~aspi.lst", cmoForce
    END

ERRQUIT:
    i% = DoMsgBox(CORRUPT$, ERRORSTRING$, MB_OK+MB_TASKMODAL+MB_ICONHAND)
    nRc% = RestoreScreenSave()
    END


BADPATH:
    sz$ = UIStartDLG(CUIDLL$, BADPATH, "FQuitDlgProc", 0, "")
    IF sz$ = "CONTINUE" THEN
        UIPop 1
    ELSEIF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO BADPATH
    ELSE
        UIPop 1
    END IF
    RETURN

DSKSPCE:
    sz$ = UIStartDLG(CUIDLL$, DSKSPCE, "FQuitDlgProc", 0, "")
    IF sz$ = "CONTINUE" THEN
        UIPop 1
    ELSEIF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO DSKSPCE
    ELSE
        UIPop 1
    END IF
    RETURN

ASKQUIT:
    sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")
    IF sz$ = "EXIT" THEN
        UIPop 2
        ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
		UIPopAll
		DoBackGround
		GOTO ASKQUIT
    ELSE
        UIPop 1
    END IF
    RETURN


ISMOSAIC:
	CorelAppDir$ = GetIniKeyString("WIN.INI", "CorelGraphics4", "Dir")
	MosDir$ = GetIniKeyString(CorelAppDir$ + "\CORELAPP.INI", "Config", "MosaicDir")
	IF MosDir$ <> "" THEN
	  SetSymbolValue "EditTextIn", MosDir$
	  SetSymbolValue "EditFocus", "END"
	  sz$ = UIStartDlg("stv.dll", MOSAIC, "FEdit1DlgProc", 0, "")
	  IF sz$ = "BACK" THEN
		UIPop 1
		DoTheMosaic% = 1
''		GOTO ENDOFINSTALL
	  ELSEIF sz$ = "EXIT" THEN                   
	    UIPop 1
	    GOSUB ASKQUIT
	    GOTO ISMOSAIC
''	    GOTO ENDOFINSTALL
	  ELSEIF sz$ = "CONTINUE" THEN
	    DoTheMosaic% = 2
		UIPop 1
	  END IF
	END IF    
	RETURN


SUB DoBackGround STATIC
	DLL$ = "stv.dll"
    stm$ = UIStartDlg(DLL$, TESTBACK, "FModelessDlgProc", 0, "")
	IF InstallType = OEMVERSION THEN
	    nReturn% = SetOEMText(OEM_NAME_PLATE$)
	    stm$ = UIStartDlg(DLL$, OEMINFO, "FOEMTextProc", 0, "")
	END IF
END SUB



SUB CheckPath STATIC 
    oldpath$ = GetIniKeyString("WIN.INI", "CorelSCSI", "installed")
    cdpath$ = GetIniKeyString("WIN.INI", "CorelSCSI", "wtbackup")

    IF oldpath$ <> "" THEN
      DEST$ = oldpath$
      CallBackDlg$ = "FEdit1DlgProc"
    ELSEIF cdpath$ <> "" THEN
      i% = LEN(cdpath$)

      oldestpath$=MID$(cdpath$, i%, 1)
      IF oldestpath$ = "\" THEN
	oldestpath$ = MID$(cdpath$, 1, i%-1)
      ELSE
	oldestpath$ = cdpath$
      ENDIF

      IF oldestpath$ = "C:\CORELDRV\SCSIUTIL" THEN
	oldestpath$ = "C:\CORELDRV"
      ENDIF

      DEST$ = oldestpath$
      CallBackDlg$ = "FEdit1DlgProc"

    ELSE
      CallBackDlg$ = "FEditDlgProc"

    END IF
    SetSymbolValue "EditTextIn", DEST$
    SetSymbolValue "EditFocus", "END"
END SUB


'** Purpose:
'**     Builds the copy list and performs all installation operations.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB Install STATIC

    UIPopAll
    ClearCopyList
    AddOptFilesToCopyList UNIFILES
    AddOptFilesToCopyList CDFILES
    AddOptFilesToCopyList CORELBOOKFILES
    AddOptFilesToCopyList WIN_CONFIGFILES
    AddOptFilesToCopyList DOS_CONFIGFILES
    AddOptFilesToCopyList NECESSARY_FILES
	AddOptFilesToCopyList WIN_TWAINFILES				'' in the PowerPak case this is Mosaic
 
	IF InstallType <> CORELCDPAK  THEN			'' takes care of the files different from Pak and SCSI2 and OEM
		AddOptFilesToCopyList WIN_BACKUPFILES
    	AddOptFilesToCopyList WIN_TOOLSFILES
	    AddOptFilesToCopyList DOS_BACKUPFILES
	    AddOptFilesToCopyList DOS_TOOLSFILES                                                           
	ELSEIF InstallType = CORELCDPAK AND DiskOrCd = CD_DISK 	AND GetListItem(CHECKSTATES$, WIN_TWAINFILES) = "ON" THEN                       '' or the mosaic files 
''     		CorelAppDir$ = GetIniKeyString("WIN.INI", "CorelGraphics4", "Dir")
''     		MosDir$ = GetIniKeyString(CorelAppDir$ + "\CORELAPP.INI", "Config", "MosaicDir")
''			IF MosDir$ <> "" THEN
''			  SetSymbolValue "EditTextIn", MosDir$
''			  SetSymbolValue "EditFocus", "END"
''			  sz$ = UIStartDlg("stv.dll", MOSAIC, "FEdit1DlgProc", 0, "")
''			  IF sz$ = "BACK" THEN
''				UIPop 1
''				DoTheMosaic% = 1
''				GOTO ENDOFINSTALL
''			  ELSEIF sz$ = "EXIT" THEN                   
''			    UIPop 1
''			    DoTheMosaic% = 2
''			    GOTO ENDOFINSTALL
''			  ELSEIF sz$ = "CONTINUE" THEN
''				UIPop 1
''			  END IF
''			END IF    

	 		IF MosDir$ = "" THEN    
	     	  CreateIniKeyValue "WIN.INI", "CorelGraphics4", "Dir", DEST$ + "\MOSAIC\CONFIG", cmoOverwrite
	     	  CreateDir DEST$ + "\MOSAIC\CONFIG", cmoNone
	     	  CreateIniKeyValue DEST$ + "\MOSAIC\CONFIG\CORELAPP.INI", "Config", "ProgramsDir", DEST$ + "\MOSAIC\PROGRAMS", cmoOverwrite
	     	  CreateIniKeyValue DEST$ + "\MOSAIC\CONFIG\CORELAPP.INI", "Config", "CustomDir", DEST$ + "\MOSAIC\CUSTOM", cmoOverwrite
	     	  CreateIniKeyValue DEST$ + "\MOSAIC\CONFIG\CORELAPP.INI", "Config", "MosaicDir", DEST$ + "\MOSAIC\PROGRAMS", cmoOverwrite
	     	  CreateIniKeyValue DEST$ + "\MOSAIC\CONFIG\CORELAPP.INI", "Config", "FiltersDir", DEST$ + "\MOSAIC\PROGRAMS", cmoOverwrite
	     	  CreateIniKeyValue DEST$ + "\MOSAIC\CONFIG\CORELAPP.INI", "Config", "DataDir", DEST$ + "\MOSAIC\PROGRAMS\DATA", cmoOverwrite
	 		END IF

	END IF	

	    
    CreateDir DEST$, cmoNone
    CopyFilesInCopyList


	   CreateIniKeyValue "WIN.INI", "CorelSCSI", "installed", DEST$, cmoOverwrite
	   installed$=DEST$ + "\CRLSCSI.INI"
           APPS% = 0
           oldval$ = GetIniKeyString(installed$, "apps", "apps")


       IF oldval$ <> "" THEN
	     previous% = VAL(oldval$)
	   ELSE
	     previous% = 0
	   ENDIF

	   oldval$ = ""

	   IF GetListItem(CHECKSTATES$, UNIFILES) = "ON" THEN
	     APPS% = APPS% + 8
           ENDIF

	   IF GetListItem(CHECKSTATES$, CDFILES) = "ON" THEN
	     APPS% = APPS% + 84
	   ENDIF

	   IF GetListItem(CHECKSTATES$, WIN_BACKUPFILES) = "ON" THEN 
	     APPS% = APPS% + 1
	     catdir$ = DEST$ + "\CATALOG"
	     IF EXISTS(catdir$+"\NUL") = FALSE THEN
	       MKDIR catdir$
         ENDIF  
	   ELSEIF GetListItem(CHECKSTATES$, DOS_BACKUPFILES) = "ON" THEN
	     APPS% = APPS% + 1
	     catdir$ = DEST$ + "\CATALOG"
	     IF EXISTS(catdir$+"\NUL") = FALSE THEN
	       MKDIR catdir$
             ENDIF
	   ENDIF

	   IF GetListItem(CHECKSTATES$, WIN_TOOLSFILES) = "ON" THEN
	     APPS% = APPS% + 2
	   ELSEIF GetListItem(CHECKSTATES$, DOS_TOOLSFILES) = "ON" THEN
	     APPS% = APPS% + 2
	   ENDIF

           APPS% = APPS% OR previous%
	   appinstalled$=STR$(APPS%)
	   CreateIniKeyValue installed$, "apps", "apps", appinstalled$, cmoOverWrite
	   appinstalled$ = ""

	   CreateIniKeyValue installed$, "CDROM Drivers", "DRIVERNAME", "MSCD001", cmoOverWrite
	   CreateIniKeyValue installed$, "UNI Drivers", "USEEMS", "YES", cmoOverWrite
	   CreateIniKeyValue installed$, "CORELCDX", "DRIVERNAME", "MSCD001", cmoOverWrite
        
        IF InstallType = CORELCDPAK THEN
        	groupname$ = "Corel CD PowerPak!"
        ELSE
			groupname$ = "CorelSCSI 2"
		END IF


	   IF InstallType = CORELCDPAK AND DiskOrCD = DISK THEN
	     GOTO NOCDSTUFF
	   ENDIF

	   CreateProgmanGroup groupname$, "", cmoVital
	   ShowProgmanGroup groupname$, 1, cmoVital

	   windows$ = GetWindowsDir()
           CreateProgmanItem groupname$, "SCSI Readme", DEST$+"\readme.hlp", "", cmoOverwrite

       IF GetListItem(CHECKSTATES$, WIN_CONFIGFILES) = "ON" THEN
 	     CreateProgmanItem groupname$, "SCSIConfig", DEST$+"\scsicnfg.exe", "", cmoOverwrite
	   ENDIF
 
	   IF GetListItem(CHECKSTATES$, CORELBOOKFILES) = "ON" THEN
	     CreateProgmanItem groupname$, "CorelBook", DEST$+"\crlbook.exe", "", cmoOverwrite
	     CreateIniKeyValue "WIN.INI", "FONTS", "CorelBook View", "cbkview.fon", cmoOverwrite
	   ENDIF

	   IF GetListItem(CHECKSTATES$, WIN_TOOLSFILES) = "ON" THEN
	     CreateProgmanItem groupname$, "SCSITools", DEST$+"\scsitool.exe", "", cmoOverwrite
	   ENDIF

	   IF GetListItem(CHECKSTATES$, WIN_BACKUPFILES) = "ON" THEN
	     CreateProgmanItem groupname$, "SCSIBackup", DEST$+"\tapeback.exe", "", cmoOverwrite
	   ENDIF

	   IF GetListItem(CHECKSTATES$, CDFILES) = "ON" THEN

         CreateProgmanItem groupname$, "CDAudio", DEST$+"\cdaudio2.exe", "", cmoOverwrite
	     CreateProgmanItem groupname$, "CDBrowser", DEST$+"\cdbrowse.exe", "", cmoOverwrite
	     CreateProgmanItem groupname$, "Wave Edit", DEST$+"\windat.exe", "", cmoOverwrite
	     CreateProgmanItem groupname$, "PhotoCD", DEST$+"\pcdscsi.exe", "", cmoOverwrite
	     windows$ = GetWindowsDir()
	     CreateProgmanItem groupname$, "Wallpaper Flipper", windows$+"wflipcnf.exe", "", cmoOverwrite
	   ENDIF

	   IF GetListItem(CHECKSTATES$, WIN_TWAINFILES) = "ON" THEN                       '' or the mosaic files 
		 IF InstallType <> CORELCDPAK THEN
	        windows$ = GetWindowsDir()
	        windows$ = windows$ + "twain\cortwain"
            cortwainini$ = windows$+"\CORTWAIN.INI"
	        CreateIniKeyValue cortwainini$, "KODAK", "firmware RFS 2035", windows$+"\rfs2035.bin", cmoOverWrite
	        CreateIniKeyValue cortwainini$, "KODAK", "load RFS 2035", windows$+"\ldkodak.exe", cmoOverWrite
	        CreateProgmanItem groupname$, "Calibrate Kodak RSF2035", windows$+"\ldkodak.exe " + windows$ + "\rfs2035.bin", "", cmoOverwrite
	        CreateProgmanItem groupname$, "Corel Twain Sample App", windows$+"\ctsample.exe", "", cmoOverwrite
	     ELSE					'' it would be an else when I add the mosaic files in.

			IF MosDir$ <> "" THEN
			    CreateProgmanItem groupname$, "CorelMOSAIC!", MosDir$ + "\CORELMOS.EXE", "", cmoOverwrite
			ELSE
			    CreateProgmanItem groupname$, "CorelMOSAIC!", DEST$ + "\mosaic\programs\corelmos.exe ", "", cmoOverwrite
			    CreateIniKeyValue DEST$ + "\MOSAIC\CONFIG\CORELFLT.INI", "ColorPath", "CircuitPath", DEST$ + "\MOSAIC\CUSTOM", cmoOverwrite
			    CreateIniKeyValue DEST$ + "\MOSAIC\CONFIG\CORELFLT.INI", "ColorPath", "CurvePath", DEST$ + "\MOSAIC\CUSTOM", cmoOverwrite
			    CreateIniKeyValue DEST$ + "\MOSAIC\CONFIG\CORELPRN.INI", "ColorPath", "CircuitPath", DEST$ + "\MOSAIC\CUSTOM", cmoOverwrite
			END IF
	     ENDIF

NOCDSTUFF:	     

       ENDIF

ENDOFINSTALL:
END SUB


'**
'** Purpose:
'**     Adds the specified option files to the copy list.
'** Arguments:
'**     ftype%  - type of files to add, one of the following:
'**             APPFILES, OPTFILES1, OPTFILES2
'** Returns:
'**     none.
'*************************************************************************
SUB AddOptFilesToCopyList (ftype%) STATIC
    windows$ = GetWindowsDir()
    winsystem$ = windows$ + "SYSTEM"
	SrcDir$ = GetSymbolValue("STF_SRCDIR")

    IF ftype% = NECESSARY_FILES THEN
		AddSectionFilesToCopyList "Necessary", SrcDir$, DEST$
		SrcDir$ = ""
    ELSEIF GetListItem(CHECKSTATES$, ftype%) = "ON" THEN
		SrcDir$ = GetSymbolValue("STF_SRCDIR")
		IF ftype% = UNIFILES THEN
		    AddSectionFilesToCopyList "UniFiles", SrcDir$, DEST$
		ELSEIF ftype% = CDFILES THEN
		    AddSectionFilesToCopyList "CDFiles", SrcDir$, DEST$
		    AddSectionFilesToCopyList "ARTshow", SrcDir$, windows$       
		    AddSectionFilesToCopyList "ARTshow_DLL", SrcDir$, winsystem$       
		    AddSectionFilesToCopyList "PhotoCD_DLL", SrcDir$, winsystem$       
		ELSEIF ftype% = CORELBOOKFILES THEN
            AddSectionFilesToCopyList "CorelBookFiles", SrcDir$, DEST$
		    AddSectionFilesToCopyList "CorelBookFont", SrcDir$, winsystem$       
		ELSEIF ftype% = WIN_BACKUPFILES THEN
            AddSectionFilesToCopyList "WINBackupFiles", SrcDir$, DEST$
		ELSEIF ftype% = WIN_TOOLSFILES THEN
            AddSectionFilesToCopyList "WINToolsFiles", SrcDir$, DEST$
		ELSEIF ftype% = WIN_CONFIGFILES THEN
            AddSectionFilesToCopyList "WINConfigFiles", SrcDir$, DEST$
		ELSEIF ftype% = WIN_TWAINFILES THEN                           
		    IF InstallType <> CORELCDPAK THEN
		       AddSectionFilesToCopyList "TwainDLL", SrcDir$, windows$         '' special dll
		       windows$ = windows$ + "TWAIN\CORTWAIN"
		       AddSectionFilesToCopyList "WINTwainFiles", SrcDir$, windows$    '' all others
		       windows$ = windows$ + "\OEMTWAIN"
		       AddSectionFilesToCopyList "OEMTwainFiles", SrcDir$, windows$    '' add OEM Files
		    ELSE 					'' ************ otherwise do mosaic here
	 
			 	IF DoesIniKeyExist("WIN.INI", "CorelGraphics4", "Dir") = 1 THEN
		     		CorelAppDir$ = GetIniKeyString("WIN.INI", "CorelGraphics4", "Dir")
		     		MosDir$ = GetIniKeyString(CorelAppDir$ + "\CORELAPP.INI", "Config", "MosaicDir")
		     		IF DoesFileExist(MosDir$ + "\CORELMOS.EXE", femReadWrite) = 1 THEN
		       			AddSectionFilesToCopyList "PcdMosFiles", SrcDir$, MosDir$
		       			AddSectionFilesToCopyList "PcdMosUtils", SrcDir$, MosDir$
					ELSE				'' just in case it really isn't there add all the files
			      		AddSectionFilesToCopyList "PcdMosFiles", SrcDir$, DEST$ + "\MOSAIC\PROGRAMS"
			      		AddSectionFilesToCopyList "PcdMosUtils", SrcDir$, DEST$ + "\MOSAIC\CUSTOM"
			      		AddSectionFilesToCopyList "PcdMosInis", SrcDir$, DEST$ + "\MOSAIC\CONFIG"
		    	  		AddSectionFilesToCopyList "PcdMosData", SrcDir$, DEST$ + "\MOSAIC\PROGRAMS\DATA"
		     		END IF 
		 		ELSE 
		      		AddSectionFilesToCopyList "PcdMosFiles", SrcDir$, DEST$ + "\MOSAIC\PROGRAMS"
		      		AddSectionFilesToCopyList "PcdMosUtils", SrcDir$, DEST$ + "\MOSAIC\CUSTOM"
		      		AddSectionFilesToCopyList "PcdMosInis", SrcDir$, DEST$ + "\MOSAIC\CONFIG"
		      		AddSectionFilesToCopyList "PcdMosData", SrcDir$, DEST$ + "\MOSAIC\PROGRAMS\DATA"
		 		END IF
			END IF


		ELSEIF ftype% = DOS_BACKUPFILES THEN
            AddSectionFilesToCopyList "DOSBackupFiles", SrcDir$, DEST$
		ELSEIF ftype% = DOS_TOOLSFILES THEN
            AddSectionFilesToCopyList "DOSToolsFiles", SrcDir$, DEST$
		ELSEIF ftype% = DOS_CONFIGFILES THEN
		    AddSectionFilesToCopyList "DOSConfigFiles", SrcDir$, DEST$
		END IF
        SrcDir$ = ""
    END IF

END SUB



'** Purpose:
'**     Sets the Checkstate list.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB SetCheckStateList STATIC
	IF InstallType = CORELSCSI20 THEN
	    FOR i% = 1 TO 11 STEP 1                  '' do the setup of entire selection
	       AddListItem CHECKSTATES$, "ON"
	    NEXT i%      
	    ReplaceListItem CHECKSTATES$, 8, "OFF"		'' no more DBACKUP
	ELSEIF InstallType = CORELCDPAK THEN			'' lets pretend MOSAIC isn't in here yet
		AddListItem CHECKSTATES$, "OFF"			'' the UNI portion selection

		IF DiskOrCD = DISK THEN
		  AddListItem CHECKSTATES$, "ON"			'' this is the drivers and cdex
		  AddListItem CHECKSTATES$, "OFF"		'' this is corelbook
		ELSE
          AddListItem CHECKSTATES$, "ON"
	      AddListItem CHECKSTATES$, "ON"
	    END IF

        AddListItem CHECKSTATES$, "OFF"			'' win backup
        AddListItem CHECKSTATES$, "OFF"			'' win tools

		IF DiskOrCD = DISK THEN
        	AddListItem CHECKSTATES$, "OFF"       	'' this is the WinConfig Check
		ELSE		
        	AddListItem CHECKSTATES$, "ON"       	'' this is the WinConfig Check
       	END IF

		IF DiskOrCD = DISK THEN
        	AddListItem CHECKSTATES$, "OFF"       	'' this is the CORELMOSAIC Check
		ELSE		
        	AddListItem CHECKSTATES$, "ON"       	'' this is the CORELMOSAIC Check
       	END IF

	    FOR i% = 8 TO 9 STEP 1                  '' do the setup of Power Pak selection
	       AddListItem CHECKSTATES$, "OFF"
	    NEXT i%

		IF DiskOrCD = DISK THEN
        	AddListItem CHECKSTATES$, "OFF"				'' DOS Config check box
        ELSE
        	AddListItem CHECKSTATES$, "ON"				'' DOS Config check box
        END IF

        AddListItem CHECKSTATES$, "ON"				'' Necessary
	ELSEIF	InstallType = OEMVERSION  THEN
		IF CheckIfOEM(InstallSet, OEM_UNIVERSAL) = 1 THEN	'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			
		            
		IF CheckIfOEM(InstallSet, OEM_CDSTUFF) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			

		IF CheckIfOEM(InstallSet, OEM_CORELBOOK) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			

		IF CheckIfOEM(InstallSet, OEM_WINBACKUP) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			

		IF CheckIfOEM(InstallSet, OEM_WINTOOLS) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			

		IF CheckIfOEM(InstallSet, OEM_WINCONFIG) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			

		IF CheckIfOEM(InstallSet, OEM_TWAIN) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			

		IF CheckIfOEM(InstallSet, OEM_DOSBACKUP) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			

		IF CheckIfOEM(InstallSet, OEM_DOSTOOLS) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$,"ON"
		ELSE 
			AddListItem CHECKSTATES$,"OFF"
		END IF			

		IF CheckIfOEM(InstallSet, OEM_DOSCONFIG) = 1 THEN		'' 1 being true (is in the bitflag)
			AddListItem CHECKSTATES$, "ON"
		ELSE 
			AddListItem CHECKSTATES$, "OFF"
		END IF			

		AddListItem CHECKSTATES$, "ON"							'' Necessary
	END IF
END SUB


'**
'** Purpose:
'**     Recalculates disk space for the given option files and sets
'**     the status info symbol "StatusItemsText".
'** Arguments:
'**     ftype% - type of files to add, one of the following:
'**             UNIFILES, CDFILES  etc
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcOptFiles (ftype%) STATIC

    CursorSave% = ShowWaitCursor()

    ClearCopyList
    AddOptFilesToCopyList ftype%


    fExtra% = 0
    IF ftype% = UNIFILES THEN
	ListSym$ = UNINEED$
    ELSEIF ftype% = CDFILES THEN
	ListSym$ = CDNEED$
    ELSEIF ftype% = CORELBOOKFILES THEN
	ListSym$ = CORELBOOKNEED$
    ELSEIF ftype% = WIN_BACKUPFILES THEN
	ListSym$ = WIN_BACKUPNEED$
    ELSEIF ftype% = WIN_TOOLSFILES THEN
	ListSym$ = WIN_TOOLSNEED$
    ELSEIF ftype% = WIN_CONFIGFILES THEN
	ListSym$ = WIN_CONFIGNEED$
    ELSEIF ftype% = WIN_TWAINFILES THEN
      IF InstallType = CORELCDPAK AND DiskOrCd = CD_DISK THEN
   		ListSym$ = PCDMOSNEED$
   	  ELSE
		ListSym$ = WIN_TWAINNEED$        				'' Mosaic in case of PowerPak
	  END IF
    ELSEIF ftype% = DOS_BACKUPFILES THEN
	ListSym$ = DOS_BACKUPNEED$
    ELSEIF ftype% = DOS_TOOLSFILES THEN
	ListSym$ = DOS_TOOLSNEED$
    ELSEIF ftype% = DOS_CONFIGFILES THEN
	ListSym$ = DOS_CONFIGNEED$
    ELSEIF ftype% = NECESSARY_FILES THEN
	ListSym$ = NECESSARY_NEED$
    END IF

    StillNeed& = GetCopyListCost(EXTRACOSTS$, ListSym$, "")

    cost& = 0
    FOR i% = 1 TO 26 STEP 1
        cost&  = cost& + VAL(GetListItem(ListSym$, i%))
    NEXT i%
    ReplaceListItem STATUSTEXT$, ftype%, STR$(cost& / 1024) + " K"

    IF StillNeed& > 0 THEN
        ReplaceListItem BIGLIST$, ftype%, "YES"
    ELSE
        ReplaceListItem BIGLIST$, ftype%, ""
    END IF

    IF fExtra% THEN
        ReplaceListItem EXTRACOSTS$, ndrive%, "0"
    END IF
    RestoreCursor CursorSave%
    ListSym$ = ""
END SUB


'**
'** Purpose:
'**     Recalculates disk space and sets option status info according
'**     to the current destination path.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcPath STATIC

    CursorSave% = ShowWaitCursor()

    RecalcOptFiles UNIFILES
    RecalcOptFiles CDFILES
    RecalcOptFiles CORELBOOKFILES
    RecalcOptFiles WIN_BACKUPFILES
    RecalcOptFiles WIN_TOOLSFILES
    RecalcOptFiles WIN_CONFIGFILES
    RecalcOptFiles WIN_TWAINFILES
    RecalcOptFiles DOS_BACKUPFILES
    RecalcOptFiles DOS_TOOLSFILES
    RecalcOptFiles DOS_CONFIGFILES
    RecalcOptFiles NECESSARY_FILES

    RestoreCursor CursorSave%
END SUB


'**
'** Purpose:
'**     Sets drive status info according to latest disk space calcs.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB SetDriveStatus STATIC

    drive$ = MID$(DEST$, 1, 1)
    ndrive% = ASC(ucase$(drive$)) - ASC("A") + 1
    cost& = VAL(GetListItem(UNINEED$, ndrive%)) + VAL(GetListItem(CDNEED$,ndrive%)) + VAL(GetListItem(CORELBOOKNEED$,ndrive%))
    cost& = cost& + VAL(GetListItem(WIN_BACKUPNEED$, ndrive%)) + VAL(GetListItem(WIN_TOOLSNEED$, ndrive%)) + VAL(GetListItem(WIN_CONFIGNEED$, ndrive%))
    cost& = cost& + VAL(GetListItem(DOS_BACKUPNEED$, ndrive%)) + VAL(GetListItem(DOS_TOOLSNEED$, ndrive%))
    cost& = cost& + VAL(GetListItem(DOS_CONFIGNEED$, ndrive%)) + VAL(GetListItem(NECESSARY_NEED$, ndrive%))
	
	IF InstallType = CORELCDPAK AND DiskOrCd = CD_DISK THEN
		cost& = cost& + VAL(GetListItem(PCDMOSNEED$, ndrive%))
	ELSE		
		cost& = cost& + VAL(GetListItem(WIN_TWAINNEED$, ndrive%))
	END IF
	
	IF cost& < 0 THEN
		cost& = 0
	END IF

    free& = GetFreeSpaceForDrive(drive$)
    ReplaceListItem DRIVETEXT$, 2, STR$(cost& / 1024) + " K"
    ReplaceListItem DRIVETEXT$, 3, STR$(free& / 1024) + " K"

END SUB

